#pragma once
#include "handmade.h"

struct TileChunk {
    uint32 *tiles;
};

struct TileChunkPosition {
    uint32 tileChunkX;
    uint32 tileChunkY;

    uint32 relTileX;
    uint32 relTileY;
};

struct TileMapPosition {
    // tile map x and y and tile x and y packed, lower 8 bits are tile X,Y and upper 24 bits map X,Y
    // ---- ---- ---- ---- ---- ---- : ---- ----
    // TILE MAP ORD                  : TILE ORD
    uint32 absTileX;
    uint32 absTileY;

    // Sub-tile position
    real32 x;
    real32 y;
};

struct TileMap {
    uint32 chunkShift;
    uint32 chunkMask;
    uint32 chunkDim;

    real32 tileSideInMeters;
    int32 tileSideInPixels;
    real32 metersToPixels;

    uint32 tileChunkCountX;
    uint32 tileChunkCountY;

    TileChunk *tileChunks;
};
